// подключение библиотек
#include "Wire.h"
#include "HMC5883L.h"

HMC5883L sensor;

void setup(){
  // запуск последовательного порта
  Serial.begin(9600);
  // запуск I2C
  Wire.begin();
  // создание экземпляра HMC5883L 
  sensor = HMC5883L();  
  // инициализация HMC5883L
  setupHMC5883L();       
}

void loop(){
  float heading = getHeading();
  Serial.println(heading);
  delay(250);
}

// инициализация HMC5883L, и проверка наличия ошибок
void setupHMC5883L(){
  
  int error;  
  // чувствительность датчика из диапазона: 0.88, 1.3, 1.9, 2.5, 4.0, 4.7, 5.6, 8.1
  error = sensor.SetScale(0.88); 
  // проверка на ошибку
  if(error != 0) 
      Serial.println(sensor.GetErrorText(error)); 
  // установка режима измерений как Continuous (продолжительный)
  error = sensor.SetMeasurementMode(Measurement_Continuous); 
  // проверка на ошибку
  if(error != 0) 
     Serial.println(sensor.GetErrorText(error)); 
}
// считывание данных с HMC5883L и рассчет  направления
float getHeading(){
  // получить масштабированные элементы с датчика
  MagnetometerScaled scaled = compass.ReadScaledAxis(); 
  // высчитать направление
  float heading = atan2(scaled.YAxis, scaled.XAxis);    

  // коррекция значения с учетом знаков
  if(heading < 0) heading += 2*PI;
  if(heading > 2*PI) heading -= 2*PI;
  // перевод радианов в градусы
  return heading * RAD_TO_DEG; 
}

